#! /usr/bin/env python
# -*- coding: utf-8 -*-

# ------------
#| Change Log |
# ------------
# Rel 0.1: Initial release. Inspired by Rich2005 in post:
# https://www.gimp-forum.net/Thread-Polygonal-designs-and-intersections?highlight=unicode
# Rel 0.2: Add repeating the character
# Rel 0.3: Add justification
# Rel 0.4: Add use to BabelMap or custom text,add option "Centered".

from gimpfu import *
import math

def python_unicode_signs_mix(img,layer,color,size,select,repeteat,many,margin,wx,hy,letter_spacing,line_spacing,centered,flip,rotate,angle,crop):
	
	pdb.gimp_image_undo_group_start(img)
	pdb.gimp_context_push()
	
	if select==0:
		fontname = u'\u2680'
		name = " DIE FACE-1"
	if select==1:
		fontname = u'\u2681'
		name = " DIE FACE-2"
	if select==2:
		fontname = u'\u2682'
		name = " DIE FACE-3"
	if select==3:
		fontname = u'\u2683'
		name = " DIE FACE-4"
	if select==4:
		fontname = u'\u2684'
		name = " DIE FACE-5"
	if select==5:
		fontname = u'\u2685'
		name = " DIE FACE-6"
	if select==6:
		fontname = u'\u2672'
		name = " UNIVERSAL RECYCLING SYMBOL"
	if select==7:	
		fontname = u'\u267B'
		name = " BLACK UNIVERSAL RECYCLING SYMBOL"
	if select==8:
		fontname = u'\u2686'	
		name = " WHITE CIRCLE WITH DOT RIGHT"
	if select==9:
		fontname = u'\u2687'	
		name = " WHITE CIRCLE WITH TWO DOTS"
	if select==10:
		fontname = u'\u2688'	
		name = " BLACK CIRCLE WITH WHITE DOT RIGHT"
	if select==11:
		fontname = u'\u2689'	
		name = " BLACK CIRCLE WITH TWO WHITE DOTS"
	if select==12:
		fontname = u'\u2690'
		name = " WHITE FLAG"
	if select==13:
		fontname = u'\u2691'
		name = " BLACK FLAG"
	if select==14:
		fontname = u'\u2692'
		name = " HAMMER AND PICK"
	if select==15:
		fontname = u'\u2693'
		name = " ANCHOR"
	if select==16:
		fontname = u'\u2694'
		name = " CROSSED SWORDS"
	if select==17:	
		fontname = u'\u2695'
		name = " STAFF OF AESCULAPIUS"
	if select==18:
		fontname = u'\u2696'
		name = " SCALES"
	if select==19:
		fontname = u'\u2697'
		name = " ALEMBIC"
	if select==20:
		fontname = u'\u2698'
		name = " FLOWER"
	if select==21:
		fontname = u'\u2699'
		name = " GEAR"
	if select==22:
		fontname = u'\u269A'
		name = " STAFF OF HERMES"
	if select==23:
		fontname = u'\u269B'
		name = " ATOM SYMBOL"
	if select==24:
		fontname = u'\u269C'
		name = " FLEUR-DE-LIS"
	if select==25:
		fontname = u'\u26A0'
		name = " WARNING SIGN"
	if select==26:
		fontname = u'\u26A1'
		name = " HIGH VOLTAGE SIGN"
	if select==27:	
		fontname = u'\u26AD'
		name = " MARRIAGE SYMBOL"
	if select==28:
		fontname = u'\u26AE'
		name = " DIVORCE SYMBOL"
	if select==29:
		fontname = u'\u26AF'
		name = " UNMARRIED PARTNERSHIP SYMBOL"
	if select==30:
		fontname = u'\u26B0'
		name = " COFFIN"
	if select==31:
		fontname = u'\u26B1'
		name = " FUNERAL URN" 
	if select==32:
		fontname = u'\u26B2'
		name = " NEUTER"
	if select==33:
		fontname = u'\u26B3'
		name = " CERES"
	if select==34:
		fontname = u'\u26B4'
		name = " PALLAS"
	if select==35:
		fontname = u'\u26B5'
		name = " JUNO"
	if select==36:
		fontname = u'\u26B6'
		name = " VESTA"
	if select==37:	
		fontname = u'\u26B7'
		name = " CHIRON"
	if select==38:
		fontname = u'\u26B8'
		name = " BLACK MOON LILITH"
	if select==39:
		fontname = u'\u267E'
		name = " PERMANENT PAPER SIGN"
	if select==40:
		fontname = u'\u2639'
		name = " WHITE FROWNING FACE"
	if select==41:
		fontname = u'\u263A'
		name = " WHITE SMILING FACE"

	w = pdb.gimp_image_width(img)
	h = pdb.gimp_image_height(img)
		
	if repeteat==0:
		fn = fontname
	if repeteat==1:
		fn = many * fontname
	if repeteat==2:
		fn = many * (fontname + '\n')

	add = gimp.Layer(img, "", w, h, RGBA_IMAGE, 100, 0)
	img.add_layer(add, -1)
	layer.add_alpha()
	gimp.set_foreground(color)
	pdb.gimp_edit_clear(add)
	pdb.gimp_selection_none(img)
	tlayer = pdb.gimp_text_fontname(img, add, wx, hy, fn, margin, TRUE, size, PIXELS, fontname)

	# justification:
	pdb.gimp_text_layer_set_letter_spacing(tlayer, letter_spacing)
	pdb.gimp_text_layer_set_line_spacing(tlayer, line_spacing)
	wh = pdb.gimp_drawable_width(tlayer)
	hh = pdb.gimp_drawable_height(tlayer)
	
	if centered==1:
		centerx=w/2
		centery=h/2

		#pdb.plug_in_autocrop_layer(img, tlayer)
		adw=wh/2
		adh=hh/2
		sw=centerx - adw
		sh=centery - adh		
		pdb.gimp_layer_set_offsets(tlayer, sw, sh)
	
	# vectors	
	new_vectors = pdb.gimp_vectors_new(img, tlayer)
	x=pdb.gimp_vectors_new_from_text_layer(img, tlayer)
	pdb.gimp_image_insert_vectors(img, x, None, -1)
	active_vectors = pdb.gimp_image_get_active_vectors(img)
	active_vectors.name = active_vectors.name.replace(fontname, name)
	active_vectors.visible = True

	if flip==1:
		pdb.gimp_item_transform_flip_simple(tlayer, 0, FALSE, w/2)
		pdb.gimp_item_transform_flip_simple(active_vectors, 0, TRUE,0)		
	if flip==2:
		pdb.gimp_item_transform_flip_simple(tlayer, 1, FALSE, h/2)
		pdb.gimp_item_transform_flip_simple(active_vectors, 1, TRUE,0)
		
	if rotate==1:
		pdb.gimp_item_transform_rotate_simple(tlayer, 0, FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate_simple(active_vectors, 0, TRUE,0,0)		
	if rotate==2:
		pdb.gimp_item_transform_rotate_simple(tlayer, 1, FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate_simple(active_vectors, 1, TRUE,0,0)		
	if rotate==3:
		pdb.gimp_item_transform_rotate_simple(tlayer, 2, FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate_simple(active_vectors, 2, TRUE,0,0)
	if rotate==4:		
		pdb.gimp_item_transform_rotate(tlayer, angle*0.01745329252 ,FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate(active_vectors, angle*0.01745329252, TRUE,0,0)		
		
	pdb.gimp_floating_sel_anchor(tlayer)
	pdb.gimp_item_set_name(add, name)
	pdb.gimp_image_raise_item_to_top(img, add)
	
	# Crop & centered layer
	if crop==1:
		pdb.gimp_selection_none(img)
		pdb.plug_in_autocrop_layer(img, add)

	pdb.gimp_item_set_visible(layer, TRUE)
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(img)
		
register(
	"python_unicode_signs_mix",
	" "u'\u263A'" UNICODE Different characters "u'\u2639'"  ",
	"UTF to shape and paths v.04",
	"MareroQ",
	"GPL",
	"2019",
	"<Image>/Filters/Path/"u'\u25cf'" Unicode to shape/Signs Differents...",
	"*",
	[
	#(PF_IMAGE, "image", "Input image", None), #current image
	#(PF_DRAWABLE, "layer", "Input layer", None), #current layer
	(PF_COLOR,"color","Color to use: ", (0, 0, 0) ),
	(PF_INT,    "size", "Size: ", 100          ),
	(PF_OPTION, "select", "Shape:", 15, 
	[
	" DIE FACE-1",
	" DIE FACE-2",
	" DIE FACE-3",
	" DIE FACE-4",
	" DIE FACE-5",
	" DIE FACE-6",
	" UNIVERSAL RECYCLING SYMBOL",
	" BLACK UNIVERSAL RECYCLING SYMBOL",
	" WHITE CIRCLE WITH DOT RIGHT",
	" WHITE CIRCLE WITH TWO DOTS",
	" BLACK CIRCLE WITH WHITE DOT RIGHT",
	" BLACK CIRCLE WITH TWO WHITE DOTS",
	" WHITE FLAG",
	" BLACK FLAG",
	" HAMMER AND PICK",
	" ANCHOR",
	" CROSSED SWORDS",
	" STAFF OF AESCULAPIUS",
	" SCALES",
	" ALEMBIC",
	" FLOWER",
	" GEAR",
	" STAFF OF HERMES",
	" ATOM SYMBOL",	
	" FLEUR-DE-LIS",
	" WARNING SIGN",
	" HIGH VOLTAGE SIGN",
	" MARRIAGE SYMBOL",
	" DIVORCE SYMBOL",
	" UNMARRIED PARTNERSHIP SYMBOL",
	" COFFIN",
	" FUNERAL URN",
	" NEUTER",
	" CERES",
	" PALLAS",
	" JUNO",
	" VESTA",
	" CHIRON",
	" BLACK MOON LILITH",
	" PERMANENT PAPER SIGN",
	" WHITE FROWNING FACE",
	" WHITE SMILING FACE"
	]),
	(PF_OPTION,"repeteat", "Repeteat ? :", 0, ["Do not repeat","Horizontally "u'\u21e8'"","Vertical "u'\u21e9'""]),	
	(PF_INT,    "many", "Repeat Sign: ", 2),
	(PF_SPINNER, "margin", "Add Margin x=y (px): ", 0, (0, 5000, 1)),
	(PF_SPINNER, "wx", "Offset x (px) "u'\u21e8'": ", 0, (-1000, 5000, 1)),	
	(PF_SPINNER, "hy", "Offset y (px) "u'\u21e9'": ", 0, (-1000, 5000, 1)),	
	(PF_SPINNER, "letter_spacing", "Horizontal Spacing: ", 0, (-1000, 1000, 1, 5, 0, 0)),
	(PF_SPINNER, "line_spacing", "Vertical Spacing: ", 0, ( -1000, 1000, 1, 5, 0, 0)),
	(PF_OPTION,"centered", "Centered?", 1, ["NOT","YES"]),
	(PF_OPTION,"flip", "Mirror ? (auto-center) :", 0, ["Not mirror","HORIZONTAL "u'\u21e8'"", "VERTICAL "u'\u21e9'""]),	
	(PF_OPTION,"rotate", "Rotate ? (auto-center) :", 0, ["Not rotate","ROTATE-90", "ROTATE-180", "ROTATE-270","CUSTOM ANGLE  "u'\u21bb'""]),
	(PF_SPINNER, "angle", "Custom Angle (degre): ", 0, (1, 360, 1)),
	(PF_OPTION,"crop", "Crop empty borders?", 1, ["Do not crop","CROP"]),
	],
	[],
	python_unicode_signs_mix
	)
main()