#! /usr/bin/env python
# -*- coding: utf-8 -*-


# ------------
#| Change Log |
# ------------
# Rel 0.1: Initial release. Inspired by Rich2005 in post:
# https://www.gimp-forum.net/Thread-Polygonal-designs-and-intersections?highlight=unicode
# Rel 0.2: Add repeating the character
# Rel 0.3: Add justification
# Rel 0.4: Add use to BabelMap or custom text,add option "Centered".

from gimpfu import *

def python_unicode_to_shape_stars(img,layer,color,size,select,repeteat,many,margin,wx,hy,letter_spacing,line_spacing,centered,flip,rotate,angle,crop):

	pdb.gimp_image_undo_group_start(img)
	pdb.gimp_context_push()
	
	if select==0:
		fontname = u'\u2721'        # "STAR OF DAVID"
	if select==1:
		fontname = u'\u2722'        # "FOUR TEARDROP-SPOKED ASTERISK
	if select==2:
		fontname = u'\u2723'        # "FOUR BALLOON-SPOKED ASTERISK
	if select==3:
		fontname = u'\u2724'        # "HEAVY FOUR BALLOON-SPOKED ASTERISK
	if select==4:
		fontname = u'\u2725'        # "FOUR CLUB-SPOKED ASTERISK
	if select==5:
		fontname = u'\u2726'        # "BLACK FOUR POINTED STAR
	if select==6:
		fontname = u'\u2727'        # "WHITE FOUR POINTED STAR
	if select==7:	
		fontname = u'\u2729'        # "STRESS OUTLINED WHITE STAR
	if select==8:
		fontname = u'\u272A'        # "CIRCLED WHITE STAR
	if select==9:
		fontname = u'\u272B'        # "OPEN CENTRE BLACK STAR
	if select==10:
		fontname = u'\u272C'        # "BLACK CENTRE WHITE STAR
	if select==11:
		fontname = u'\u272D'        # "OUTLINED BLACK STAR
	if select==12:
		fontname = u'\u272E'        # "HEAVY OUTLINED BLACK STAR
	if select==13:
		fontname = u'\u272F'        # "PINWHEEL STAR
	if select==14:
		fontname = u'\u2730'        # "SHADOWED WHITE STAR
	if select==15:
		fontname = u'\u2731'        # "HEAVY ASTERISK
	if select==16:
		fontname = u'\u2732'        # "OPEN CENTRE ASTERISK
	if select==17:
		fontname = u'\u2733'        # "EIGHT SPOKED ASTERISK
	if select==18:
		fontname = u'\u2734'        # "EIGHT POINTED BLACK STAR
	if select==19:
		fontname = u'\u2735'        # "EIGHT POINTED PINWHEEL STAR
	if select==20:
		fontname = u'\u2736'        # "SIX POINTED BLACK STAR
	if select==21:
		fontname = u'\u2737'        # "EIGHT POINTED RECTILINEAR BLACK STAR
	if select==22:            
		fontname = u'\u2738'        # "HEAVY EIGHT POINTED RECTILINEAR BLACK STAR
	if select==23:
		fontname = u'\u2739'        # "TWELVE POINTED BLACK STAR
	if select==24:
		fontname = u'\u273A'        # "SIXTEEN POINTED ASTERISK
	if select==25:
		fontname = u'\u273B'        # "TEARDROP-SPOKED ASTERISK
	if select==26:
		fontname = u'\u273C'        # "OPEN CENTRE TEARDROP-SPOKED ASTERISK
	if select==27:
		fontname = u'\u273D'        # "HEAVY TEARDROP-SPOKED ASTERISK
	if select==28:
		fontname = u'\u273E'        # "SIX PETALLED BLACK AND WHITE FLORETTE
	if select==29:
		fontname = u'\u273F'        # "BLACK FLORETTE
	if select==30:
		fontname = u'\u2740'        # "WHITE FLORETTE
	if select==31:
		fontname = u'\u2741'        # "EIGHT PETALLED OUTLINED BLACK FLORETTE
	if select==32:
		fontname = u'\u2742'        # "CIRCLED OPEN CENTRE EIGHT POINTED STAR
	if select==33:
		fontname = u'\u2743'        # "HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK
	if select==34:
		fontname = u'\u2744'        # "SNOWFLAKE
	if select==35:
		fontname = u'\u2745'        # "TIGHT TRIFOLIATE SNOWFLAKE
	if select==36:
		fontname = u'\u2746'        # "HEAVY CHEVRON SNOWFLAKE
	if select==37:
		fontname = u'\u2747'        # "SPARKLE
	if select==38:
		fontname = u'\u2748'        # "HEAVY SPARKLE
	if select==39:
		fontname = u'\u2749'        # "BALLOON-SPOKED ASTERISK
	if select==40:
		fontname = u'\u274A'        # "EIGHT TEARDROP-SPOKED PROPELLER ASTERISK
	if select==41:
		fontname = u'\u274B'        # "HEAVY EIGHT TEARDROP-SPOKED PROPELLER ASTERISK


	w = pdb.gimp_image_width(img)
	h = pdb.gimp_image_height(img)
	name = fontname	
	if repeteat==0:
		fn = fontname
	if repeteat==1:
		fn = many * fontname
	if repeteat==2:
		fn = many * (fontname + '\n')

	add = gimp.Layer(img, "", w, h, RGBA_IMAGE, 100, 0)
	img.add_layer(add, -1)
	layer.add_alpha()
	gimp.set_foreground(color)
	pdb.gimp_edit_clear(add)
	pdb.gimp_selection_none(img)
	tlayer = pdb.gimp_text_fontname(img, add, wx, hy, fn, margin, TRUE, size, PIXELS, fontname)

	# justification:
	pdb.gimp_text_layer_set_letter_spacing(tlayer, letter_spacing)
	pdb.gimp_text_layer_set_line_spacing(tlayer, line_spacing)
	
	
	if centered==1:
		wh = pdb.gimp_drawable_width(tlayer)
		hh = pdb.gimp_drawable_height(tlayer)
		centerx=w/2
		centery=h/2
		adw=wh/2
		adh=hh/2
		sw=centerx - adw
		sh=centery - adh		
		pdb.gimp_layer_set_offsets(tlayer, sw, sh)
	
	# vectors	
	new_vectors = pdb.gimp_vectors_new(img, tlayer)
	x=pdb.gimp_vectors_new_from_text_layer(img, tlayer)
	pdb.gimp_image_insert_vectors(img, x, None, -1)
	active_vectors = pdb.gimp_image_get_active_vectors(img)
	active_vectors.name = active_vectors.name.replace(fontname, name)
	active_vectors.visible = True

	if flip==1:
		pdb.gimp_item_transform_flip_simple(tlayer, 0, FALSE, w/2)
		pdb.gimp_item_transform_flip_simple(active_vectors, 0, TRUE,0)		
	if flip==2:
		pdb.gimp_item_transform_flip_simple(tlayer, 1, FALSE, h/2)
		pdb.gimp_item_transform_flip_simple(active_vectors, 1, TRUE,0)
		
	if rotate==1:
		pdb.gimp_item_transform_rotate_simple(tlayer, 0, FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate_simple(active_vectors, 0, TRUE,0,0)		
	if rotate==2:
		pdb.gimp_item_transform_rotate_simple(tlayer, 1, FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate_simple(active_vectors, 1, TRUE,0,0)		
	if rotate==3:
		pdb.gimp_item_transform_rotate_simple(tlayer, 2, FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate_simple(active_vectors, 2, TRUE,0,0)
	if rotate==4:		
		pdb.gimp_item_transform_rotate(tlayer, angle*0.01745329252 ,FALSE, w/2, h/2)
		pdb.gimp_item_transform_rotate(active_vectors, angle*0.01745329252, TRUE,0,0)		
		
	pdb.gimp_floating_sel_anchor(tlayer)
	pdb.gimp_item_set_name(add, name)
	pdb.gimp_image_raise_item_to_top(img, add)
	
	# Crop layer
	
	if crop==1:
		pdb.gimp_selection_none(img)
		pdb.plug_in_autocrop_layer(img, add)
	
	pdb.gimp_item_set_visible(layer, TRUE)
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(img)

register(
	"python_unicode_to_shape_stars",
	""u'\u2747'" UNICODE to STAR & ASTERISK "u'\u273F'"",
	"UTF to shape and paths v.04",
	"MareroQ",
	"GPL",
	"2019",
	"<Image>/Filters/Path/"u'\u25cf'" Unicode to shape/Star & Asterisk...",
	"*",
	[
	#(PF_IMAGE, "image", "Input image", None), #current image
	#(PF_DRAWABLE, "layer", "Input layer", None), #current layer
	(PF_COLOR,"color","Color to use", (255,255,255) ),
	(PF_INT,    "size", "Size", 100          ),
	(PF_OPTION, "select", "Shape:", 52, 
	[
	u'\u2721'"    STAR OF DAVID",
	u'\u2722'"    FOUR TEARDROP-SPOKED ASTERISK",
	u'\u2723'"    FOUR BALLOON-SPOKED ASTERISK",
	u'\u2724'"    HEAVY FOUR BALLOON-SPOKED ASTERISK",
	u'\u2725'"    FOUR CLUB-SPOKED ASTERISK",
	u'\u2726'"    BLACK FOUR POINTED STAR",
	u'\u2727'"    WHITE FOUR POINTED STAR",
	u'\u2729'"    STRESS OUTLINED WHITE STAR",
	u'\u272A'"    CIRCLED WHITE STAR",
	u'\u272B'"    OPEN CENTRE BLACK STAR",
	u'\u272C'"    BLACK CENTRE WHITE STAR",
	u'\u272D'"    OUTLINED BLACK STAR",
	u'\u272E'"    HEAVY OUTLINED BLACK STAR",
	u'\u272F'"    PINWHEEL STAR",
	u'\u2730'"    SHADOWED WHITE STAR",
	u'\u2731'"    HEAVY ASTERISK",
	u'\u2732'"    OPEN CENTRE ASTERISK",
	u'\u2733'"    EIGHT SPOKED ASTERISK",
	u'\u2734'"    EIGHT POINTED BLACK STAR",
	u'\u2735'"    EIGHT POINTED PINWHEEL STAR",
	u'\u2736'"    SIX POINTED BLACK STAR",
	u'\u2737'"    EIGHT POINTED RECTILINEAR BLACK STAR",
	u'\u2738'"    HEAVY EIGHT POINTED RECTILINEAR BLACK",
	u'\u2739'"    TWELVE POINTED BLACK STAR",
	u'\u273A'"    SIXTEEN POINTED ASTERISK",
	u'\u273B'"    TEARDROP-SPOKED ASTERISK",
	u'\u273C'"    OPEN CENTRE TEARDROP-SPOKED ASTERISK",
	u'\u273D'"    HEAVY TEARDROP-SPOKED ASTERISK",
	u'\u273E'"    SIX PETALLED BLACK AND WHITE FLORETTE",
	u'\u273F'"    BLACK FLORETTE",
	u'\u2740'"    WHITE FLORETTE",
	u'\u2741'"    EIGHT PETALLED OUTLINED BLACK FLORETTE",
	u'\u2742'"    CIRCLED OPEN CENTRE EIGHT POINTED STAR",
	u'\u2743'"    HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK",
	u'\u2744'"    SNOWFLAKE",
	u'\u2745'"    TIGHT TRIFOLIATE SNOWFLAKE",
	u'\u2746'"    HEAVY CHEVRON SNOWFLAKE",
	u'\u2747'"    SPARKLE",
	u'\u2748'"    HEAVY SPARKLE",
	u'\u2749'"    BALLOON-SPOKED ASTERISK",
	u'\u274A'"    EIGHT TEARDROP PROPELLER ASTERISK",
	u'\u274B'"    HEAVY EIGHT TEARDROP PROPELLER ASTERISK", 
	]),
	(PF_OPTION,"repeteat", "Repeteat ? :", 0, ["Do not repeat","Horizontally "u'\u21e8'"","Vertical "u'\u21e9'""]),	
	(PF_INT,    "many", "Repeat Sign: ", 2),
	(PF_SPINNER, "margin", "Add Margin x=y (px): ", 0, (0, 5000, 1)),
	(PF_SPINNER, "wx", "Offset x (px) "u'\u21e8'": ", 0, (-1000, 5000, 1)),	
	(PF_SPINNER, "hy", "Offset y (px) "u'\u21e9'": ", 0, (-1000, 5000, 1)),	
	(PF_SPINNER, "letter_spacing", "Horizontal Spacing: ", 0, (-1000, 1000, 1, 5, 0, 0)),
	(PF_SPINNER, "line_spacing", "Vertical Spacing: ", 0, ( -1000, 1000, 1, 5, 0, 0)),
	(PF_OPTION,"centered", "Centered?", 1, ["NOT","YES"]),
	(PF_OPTION,"flip", "Mirror ? (auto-center) :", 0, ["Not mirror","HORIZONTAL "u'\u21e8'"", "VERTICAL "u'\u21e9'""]),	
	(PF_OPTION,"rotate", "Rotate ? (auto-center) :", 0, ["Not rotate","ROTATE-90", "ROTATE-180", "ROTATE-270","CUSTOM ANGLE  "u'\u21bb'""]),
	(PF_SPINNER, "angle", "Custom Angle: ", 0, (1, 360, 1)),
	(PF_OPTION,"crop", "Crop empty borders?", 1, ["Do not crop","CROP"]),
	],
	[],
	python_unicode_to_shape_stars
	)

main()